﻿using Infragistics.Documents.RichText;
using System;
using System.Collections.Generic;
using System.Windows;

namespace RichSpellChecking
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        TextNode nodeToUpdate;
        List<TextNode> nodes = new List<TextNode>();
        int nodeCount = 0;

        public MainWindow()
        {
            InitializeComponent();

            RichTextDocument doc = new RichTextDocument();
            doc.LoadFromPlainText(Environment.CurrentDirectory + "\\Text.txt");

            xamRichText.Document = doc;
        }

        private void btnSpell_Click(object sender, RoutedEventArgs e)
        {
            xamRichText.Tag = xamRichText.Document.GetTextInSpan(DocumentSpan.All);

            xamSpellChecker.SpellCheck();
        }

        private void xamSpellChecker_SpellCheckCompleted(object sender, Infragistics.Controls.Interactions.SpellCheckCompletedEventArgs e)
        {
            nodeToUpdate.Text = xamRichText.Tag.ToString();

            nodeCount++;

            if (nodeCount >= nodes.Count)
            {
                return;
            }
            else
            SpellCheck(nodes[nodeCount]);
        }

        private void btnSpellByTextNode_Click(object sender, RoutedEventArgs e)
        {
            foreach (var item in xamRichText.Document.RootNode.ChildNodes[0].ChildNodes)
            {
                if (item.HasChildNodes)
                {
                    foreach (var runNode in item.ChildNodes)
                    {
                        if (runNode.HasChildNodes)
                        {
                            foreach (TextNode textNode in runNode.ChildNodes)
                            {
                                nodes.Add(textNode);
                            }

                        }
                    }
                }
            }
            SpellCheck(nodes[0]);
        }

        private  void SpellCheck(TextNode textNode)
        {
            nodeToUpdate = textNode;

            xamRichText.Tag = textNode.Text;

            xamSpellChecker.SpellCheck();
        }
    }
}